unit digrmain;

interface

uses
{$if not defined(linux)}
  Windows,
{$ifend}
Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, digraph;

type
  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    procedure EndProgram(Sender: TObject);
    procedure ProgramStart(Sender: TObject);
    procedure EnProgram(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  dlitt: TDoublyLinkedDoubleInt;
  dlit: TDoublyLinkedDoubleInt;
  dg,dg2: TValuedDigraph;
  dg1: TDigraph;
  outf: textfile;

implementation

{$R *.dfm}


procedure TForm1.EndProgram(Sender: TObject);
begin
  closefile(outf);
  close;
end;

procedure TForm1.ProgramStart(Sender: TObject);
var
    dls: TDoublyLinkedIntList;
    i,j,x1,x2,x3,x4,mult: integer;
    xx: array[0..100] of ShortInt;
begin
 assignfile(outf,'out.txt');
 rewrite(outf);

 { check of TDoublyLinkedIntList:
 dls := TDoublyLinkedIntList.Create;
 writeln(outf,dls.Isempty);
 dls.Insertfront(0,2);
 writeln(outf,dls.Isempty);
 dls.Insertfront(1,3);
 dls.Insertfront(2,5);
 writeln(outf,dls.count);
 dls.Append(8,6);
 dlit := dls.First;
 writeln(outf,'1: ',dlit.value1);
 i := 1;
   repeat
     inc(i);
     dlit := dlit.Next;
     writeln(outf,i,'. ',dlit.value1,'; ',dlit.value2);
  until (dlit = dls.Last);
(* Do not destroy dlit, because then you will destroy dls.Flast ! *)
 dls.Destroy;                     }

// dg := TRedundantValuedDigraph.Create(100);
 dg := TValuedDigraph.Create(20);

 dg.ChangeTieValue(1,4,2);
 dg.ChangeTieValue(2,5,3);
 dg.ChangeTieValue(3,6,4);
 write(outf,'The digraph is ');
 if (not dg.IsCorrect) then write(outf,'not ');
 writeln(outf,' correct.');
 writeln(outf,'ErrorMessage = .',dg.ErrorMessage,'.');
 dg.WriteLists(outf);

 write(outf,'The digraph is ');
 if (not dg.IsCorrect) then write(outf,'not ');
 writeln(outf,' correct.');
 writeln(outf,'ErrorMessage = .',dg.ErrorMessage,'.');
 dg.WriteLists(outf);


 i := 0;
 mult := dg.Order-1;
 repeat
   Inc(i);
   x1 := round(random*mult)+1;
   x2 := round(random*mult)+1;
   x3 := round(random*9)-4;
   x4 := round(random*9)-4;
   if (x1 <> x2) then dg.ChangeTieValue(x1,x2,x3);
   if (x1 <> x2) then dg.IncreaseTie(x1,x2,x4);

   if (not dg.IsCorrect) then begin
     writeln(outf,'The digraph is not correct.');
     writeln(outf,'Last change ',x1,':',x2,':',x3);
     writeln(outf,'ErrorMessage = .',dg.ErrorMessage,'.');
     dg.WriteLists(outf);
    end;
   until ((dg.ErrorMessage > '') or (i >= 100));

 writeln(outf,'Order ',dg.Order);
 for i:=1 to dg.Order do writeln(outf,i:3,'. Outdegree = ',dg.OutDegree(i):3,
                                  '; Indegree = ',dg.InDegree(i):3);

 writeln(outf,'Last change ',x1,':',x2,':',x3);
 writeln(outf,'ErrorMessage = .',dg.ErrorMessage,'.');
 write(outf,'The digraph is ');
 if (not dg.IsCorrect) then write(outf,'not ');
 writeln(outf,' correct.');
 writeln(outf,'ErrorMessage = .',dg.ErrorMessage,'.');
 dg.WriteLists(outf);

 dg.WriteAdjacency(outf);

 dg2 := TValuedDigraph.Create(20);
 CopyGraph(dg,dg2);
 dg2.SetRowTo(20,dg.InTies[20]);
 dg2.WriteAdjacency(outf);
 dg2.Destroy(outf,'dg2 in DigrMain');       

 dg.Destroy(outf,'dg in DigrMain');

{
 writeln(outf,'Digraph');

 dg1 := TDigraph.Create(100);

 dg1.ChangeTieValue(1,4,0);
 dg1.ChangeTieValue(2,5,1);
 writeln(outf,'ErrorMessage = .',dg1.ErrorMessage,'.');
// dg1.ChangeTieValue(3,6,3);
// writeln(outf,'ErrorMessage = .',dg1.ErrorMessage,'.');

 write(outf,'The digraph is ');
 if (not dg1.IsCorrect) then write(outf,'not ');
 writeln(outf,' correct.');
 writeln(outf,'ErrorMessage = .',dg1.ErrorMessage,'.');
 dg1.WriteLists(outf);

 i := 0;
 mult := dg1.Order-1;
 repeat
   Inc(i);
   x1 := round(random*mult)+1;
   x2 := round(random*mult)+1;
   if (random < 0.5) then x3 := 0 else x3 := 1;
   if (x1 <> x2) then dg1.ChangeTieValue(x1,x2,x3);
   if (random < 0.5) then begin
     x4 := 1-2*dg1.TieValue(x1,x2);
     if (x1 <> x2) then dg1.IncreaseTie(x1,x2,x4);
    end;

   if (not dg1.IsCorrect) then begin
     writeln(outf,'The digraph is not correct.');
     writeln(outf,'Last change ',x1,':',x2,':',x3);
     writeln(outf,'ErrorMessage = .',dg1.ErrorMessage,'.');
     dg1.WriteLists(outf);
    end;
   until ((dg1.ErrorMessage > '') or (i >= 100));

 writeln(outf,'Order ',dg1.Order);
 for i:=1 to dg1.Order do writeln(outf,i:3,'. Outdegree = ',dg1.OutDegree(i):3,
                                  '; Indegree = ',dg1.InDegree(i):3);

 writeln(outf,'Last change ',x1,':',x2,':',x3);
 writeln(outf,'ErrorMessage = .',dg1.ErrorMessage,'.');
 write(outf,'The digraph is ');
 if (not dg1.IsCorrect) then write(outf,'not ');
 writeln(outf,' correct.');
 writeln(outf,'ErrorMessage = .',dg1.ErrorMessage,'.');
 dg1.WriteLists(outf);
// dg1.WriteAdjacency(outf);

 dg1.Destroy(outf,'dg1 in DigrMain');
}
end;

procedure TForm1.EnProgram(Sender: TObject; var Action: TCloseAction);
begin
  closefile(outf);
  close;
end;

end.
