                            (* S_SIM.PAS*)


(* This unit is for straight simulation in the Siena program. *)

Unit s_sim;

Interface

Uses classes, Dialogs, SysUtils, s_constants, slib, eight, s_re, s_ml,
     Forms, rangen, Graphics;


Type

Activity = object(MLModel)
  selected: Word;
  (* selected used in case of automatic forward model selection:
    index number of the most significant effect *)

  Graphix: Boolean;
  procedure Simulate(var outf, lf: TFileStream);
 end; (* Activity *)

var  stops, halter: Boolean; (* used for early termination in the form *)

implementation

uses siena_5, s_dat;


procedure Activity.simulate(var outf, lf: TFileStream);
var nitr,nrun: cardinal;
  sed, degmax, demod: integer;
  ix, iy: real;
  p,pp,esta: byte;
  writefreq: cardinal;
  pm,sums2: pMatrix;
  theta,sums,stats,statsplus,sumslag,statslag: pVec;
  Targets: pVec;
   (* Vector of statistics *)
  i,j,k,numberf,numberfun: Integer;
  dd: array of real;
  orderdegs: intvec;
  perc5,perc50,perc95: array of integer;
  updatestat,feasible,err,pc : Boolean;
  erstr: shortstring;
  stad: string[60]; // as in definition of ppString;
  datf,fff: textfile;
  datfn,s: shortstring;
  HeightFactor, dr, time0, time1, lm1, rlm2: real;
  x: string;
  GenerateNumber: integer;
  GenerateMany: boolean;

procedure wm(p: byte; var mm: pmatrix; var ouf: TFileStream);
var i,j: integer;
function cor(var mm: pmatrix; i,j: integer):real;
begin if (mm[i,i]*mm[j,j] > 0) then
      cor := mm[i,j]/sqrt(mm[i,i]*mm[j,j]) else cor := 0.0;
end; (* cor *)
procedure wri(xx: real; h: integer);
var x: string;
begin
  x := format('%14.4f%s',[xx,' ']);
  ouf.Write(pchar(x)^,length(x));
(*  if ((h mod 8) = 0) then writeln(ouf); *)
end; (* wri *)
begin
  for i:=1 to p do begin
   for j:=1 to i-1 do wri(cor(mm,i,j),j);
   wri(mm[i,i],i);
   for j:=i+1 to p do wri(mm[i,j],j);
   ouf.Write(pchar(eol)^,length(eol));//writeln(ouf);
  end; (* i *)
end; (* wm *)

procedure roundfreq(var w: cardinal);
  begin
  if (w < 1) then w := 1;
  if (w > 100) then w := 100;
   case w of
     3..14  : w := 10;
    15..30 : w := 20;
    31..65 : w := 50;
    66..99 : w := 100;
   end; (* case *)
end; (* roundfreq *)

procedure results(nr: integer; p: byte; m: pvec; m2: pmatrix;
                  mc: pvec; prc5,prc50,prc95: array of integer; var ouf: TFileStream);
var i: integer;
    maxt,ts: real;
    x: string;
begin (* results *)
 Heading(2,ouf,'Simulation Results.');
(* writeln(ouf,'Order of statistics : ');
 for i:=1 to p do writeln(ouf,i:2,'.  ',StatsDescriptions[i]);
 writeln(ouf); *)
 x := format('%s%d%s',['Total of ',nr,' simulation runs.'])+eol;
 ouf.Write(pchar(x)^,length(x));
 Heading(3,ouf,'Estimated means and standard deviations ');
 for i:=1 to p do begin
   x := format('%s%11.4f%s%11.4f%s',[StatsDescriptions[i],m[i],'  (',root(m2[i,i]),') '])+eol;
   ouf.Write(pchar(x)^,length(x));
 end;
 //writeln(outf);
 outf.Write(pchar(eol)^,length(eol));
  x := format('%s%7.1f%s',['(Standard errors of the mean are standard deviations divided by ',root(nr),' .)'])+eol;
  ouf.Write(pchar(x)^,length(x));

 Heading(3,ouf,'Covariance matrix simulated statistics (correlations below diagonal) ');
(* if (p > 8) then begin
   writeln(ouf,'Each row of the matrix is represented by ',
                (1+((p-1) div 8)),' output lines.');
   writeln(ouf);
  end; *)
(* If you do want the above feature, then reuse
   the writeln line in procedure wm. *)
 wm(p,m2,ouf);
 ouf.Write(pchar(eol)^,length(eol));//writeln(ouf);
 maxt := 0.0;
 selected := 0;
 Heading(3,ouf,'t-statistics for observed function values ');
 for i:=1 to p do if (i <= NumberFunctions) then begin
   if (m2[i,i] > 1e-10) then begin
     ts := (Targets[i] - m[i])/root(m2[i,i]);
     if (abs(ts) > maxt) then begin
       maxt := abs(ts);
       selected := i;
      end;
     x := format('%s%9.4f',[StatsDescriptions[i],ts])+eol;
     ouf.Write(pchar(x)^,length(x));
     end
    else  begin
      x := StatsDescriptions[i]+'   ---'+eol;
      ouf.Write(pchar(x)^,length(x));
      end;
  end;
 if (maxt < 1.6) then selected := 0 else
   begin
   if (selected >= 1) and (selected <= pmax) then selected := Functions[selected];
   end;
 ouf.Write(pchar(eol)^,length(eol));//writeln(ouf);
 if ((observations = 1) or MaxLike) then begin
   Heading(3,ouf,'autocorrelations of generated function values');
   for i:=1 to p do
    if (m2[i,i] > 1e-8) then   begin
      x := format('%s%s%7.3f',[StatsDescriptions[i],' ',mc[i]/m2[i,i]])+eol;
      ouf.Write(pchar(x)^,length(x));
    end;
  end; (* if observations = 1 *)

 n := nni[observations-1]; 
 if (OutputType >= 2) then begin
   Heading(3,ouf,'Ordered out-degrees at last observation moment');
   x := '   i'+'  obs'+'  median '+' 5 perc'+' 95 perc'+eol;
   ouf.Write(pchar(x)^,length(x));
   for i:=1 to n do begin
     x := format('%4d%s%4d%s%4d%s%4d%s%4d',[i,' ',orderdegs[i],'  ',prc5[i],'   ',prc50[i],'    ',prc95[i]])+eol;
     ouf.Write(pchar(x)^,length(x));
    end; (* for i *)
   end; (* if OutputType *)
 ouf.Write(pchar(eol)^,length(eol));//writeln(ouf);
end; (* results *)


begin (* Activity.Simulate *)
  selected := 0;
  Graphix := false;
  Heading(1,outf,'Simulations.');
  lf.Write(pchar(eol)^,length(eol));//writeln(lf);
  x := 'SIENA05'+eol;
  lf.Write(pchar(x)^,length(x));
  x := 'Date and time: '+DateTimeToStr(Now)+eol;
  lf.Write(pchar(x)^,length(x));
  Heading(1,lf,'Simulations.');
  setlength(dd,observations);
  d_estA := false;
  d_estB := false;
  d_estAB := false;
  Application.ProcessMessages;
  SetLength(perc5,nmax+1);
  SetLength(perc50,nmax+1);
  SetLength(perc95,nmax+1);
  SetLength(orderdegs,nmax+1);

  if MaxLike then Cconditional := false;
  datfn :=  pname+'.sdt';
  assign(datf,datfn);
  rewrite(datf);
  if (niter >= 2) then begin
    x := 'Simulated values of statistics written to file '+datfn+'.'+eol;
    outf.Write(pchar(x)^,length(x));
  end;
  InitialiseBase2(theta,outf,lf);
  DefineSimFunctions(outf,lf);
  FunctionEvaluations(orderdegs,halter,outf,lf, targets);
  if halter then begin
    x := 'Problem in SIM returning from procedure FunctionEvalutions.'+eol;
    outf.Write(pchar(x)^,length(x));
    //writeln(lf,'Problem in SIM returning from procedure FunctionEvalutions.');
    lf.Write(pchar(x)^,length(x));
    Halterror('initialization problem',outf,lf);
    exit;
   end;

  if MaxLike then begin
    numberfunctions := numberparameters;
    for i:=1 to numberparameters do begin
      StatsDescriptions[i] := 'minus score function for parameter ' + inttostr(i);
      targets[i] := 0.0;
     end;
   end;

  nrun := niter;
  if (nrun <= 2) then nrun := 2;
  for i:=1 to pmax do begin
    sums[i] := 0.0;
    sumslag[i] := 0.0;
    for j:=1 to pmax do begin
      sums2[i,j] := 0.0;
     end;
   end; (* i *)

  x := format('%s%d%s%d%s',['Simulations with ',NumberParameters,' parameters for ',
           NumberFunctions,' statistics.'])+eol;
           lf.Write(pchar(x)^,length(x));
  x := 'Parameter values:'+eol;
  lf.Write(pchar(x)^,length(x));
  for i:=1 to NumberParameters do begin
    x := format('%9.5f%s',[theta[i],' ']);
    lf.Write(pchar(x)^,length(x));
  end;
  lf.Write(pchar(eol)^,length(eol));//writeln(lf);
  x :='Parameter values are '+eol;
  outf.Write(pchar(x)^,length(x));
  for i:=1 to NumberParameters do   begin
    x :=format('%3d%s%s%s%10.5f',[i,'. ',AlignString(Description[i],60),' ',theta[i]])+eol;
    outf.Write(pchar(x)^,length(x));
  end;
  outf.Write(pchar(eol)^,length(eol));//writeln(outf);
  if (observations <= 1) then begin
    if VertexPar then ReportVertexParameters(outf);
    if CConditional then begin
      x := 'Conditional simulation.'+eol;
      outf.Write(pchar(x)^,length(x));
      x := format('%s%7.4f',['Observed density = ',densty])+eol;
      outf.Write(pchar(x)^,length(x));
      x := format('%s%5d',['Number of ties   = ',round(densty*n*(n-1))])+eol;
      outf.Write(pchar(x)^,length(x));
     end else begin
      x := 'Unconditional simulation.'+eol;
      outf.Write(pchar(x)^,length(x));
     end;
    x := 'Simulation method:'+eol;
    outf.Write(pchar(x)^,length(x));
    x := Gibbsstring+'.'+eol;
    outf.Write(pchar(x)^,length(x));
    x := format('%d%s',[ERGMnrun(gibbs),' steps per simulation; ']);
    outf.Write(pchar(x)^,length(x));
    x := format('%s%5.3f%s',['multiplication factor = ',rstep,'.'])+eol;
    outf.Write(pchar(x)^,length(x));
    if (Gibbs = 6)
      then begin
      x := 'The graph is treated as an undirected graph.'+eol;
      outf.Write(pchar(x)^,length(x));
      end;
    if  (Gibbs = 7)
      then begin
        x := 'The graph is treated as an asymmetric graph,'+eol;
        outf.Write(pchar(x)^,length(x));
        x := 'in which all dyads must be asymmetric.'+eol;
        outf.Write(pchar(x)^,length(x));
       end;
   end else (* observations >= 2 *) begin
     x := format('%s%2d%s',['Model Type ',ModelType,': '+ModelTypeString+'.'])+eol;
     outf.Write(pchar(x)^,length(x));
      if ReciprocityModel then  begin
        x := 'Reciprocity Model (special rate function depending on degrees).'+eol;
        outf.Write(pchar(x)^,length(x));
      end;
     if CConditional then begin
      x := 'Simulations under conditions of given distances:'+eol;
      outf.Write(pchar(x)^,length(x));
      x := 'conditioning variable is the total number of observed changes ("distance") '+eol;
      outf.Write(pchar(x)^,length(x));
      if ConditioningNetworkVariable>=1
      then begin
        x := 'in the network variable.'+eol;
        outf.Write(pchar(x)^,length(x));
      end
      else begin
        x := 'in behavioral variable '+znames[nz+ConditioningActionVariable]+eol;
        outf.Write(pchar(x)^,length(x));
      end;
      if (observations = 2)
      then begin
        x := 'Distance for simulations is ';
        outf.Write(pchar(x)^,length(x));
        if ConditioningNetworkVariable>=1
        then begin
          x := format('%5d%s',[ObservedNetworkDistance[1,1],'.'])+eol;
          outf.Write(pchar(x)^,length(x));
        end
        else begin
          x := format('%5d%s',[ObservedActionDistance[ConditioningActionVariable,1],'.'])+eol;
          outf.Write(pchar(x)^,length(x));
        end;
      end
      else begin
        x := 'Distances for simulations are'+eol;
        outf.Write(pchar(x)^,length(x));
        x := 'period   : ';
        outf.Write(pchar(x)^,length(x));
        for i:=1 to observations-1 do if not skipi[i] then begin
          x := format('%4d%s',[i,' ']);
          outf.Write(pchar(x)^,length(x));
        end;
        outf.Write(pchar(eol)^,length(eol));//writeln(outf);
        x := 'distance : ';
        outf.Write(pchar(x)^,length(x));
        for i:=1 to observations-1 do  if not skipi[i] then
        begin
        if ConditioningNetworkVariable>=1
        then begin
          x := format('%s%4d',[' ',ObservedNetworkDistance[1,i]]);
          outf.Write(pchar(x)^,length(x));
        end
        else begin
          x := format('%s%4d',[' ',ObservedActionDistance[ConditioningActionVariable,i]]);
          outf.Write(pchar(x)^,length(x));
        end;
        end;
        x := ' .'+eol;
        outf.Write(pchar(x)^,length(x));
      end;
     end else (* not Cconditional *) begin
       x := 'Simulations for a specified time.'+eol;
       outf.Write(pchar(x)^,length(x));
       x := 'Time duration for simulations ';
       outf.Write(pchar(x)^,length(x));
       if (observations >= 3) then begin
        x := 'in each period ';
        outf.Write(pchar(x)^,length(x));
       end;
       x := 'is 1.0.'+eol; (* see FRAN/SimStats in S_Base *)
       outf.Write(pchar(x)^,length(x));
      end; (* if not Cconditional *)
    if (MaxDegree < nmax) then begin
     if symmetric then  begin
     x := format('%s%d%s',
      ['All graphs are constrained to having degrees not larger than ',
      MaxDegree,'.'])+eol;
      outf.Write(pchar(x)^,length(x));
     end
     else begin
      x := format('%s%d%s',
      ['All digraphs are constrained to having outdegrees not larger than ',
      MaxDegree,'.'])+eol;
       outf.Write(pchar(x)^,length(x));
     end;
     end;

    if (not CConditional) then begin
      if MaxLike
      then begin
        x := 'Maximum Likelihood.'+eol;
        outf.Write(pchar(x)^,length(x));
      end
      else if Bayesian
      then begin
        x := 'Bayes law.'+eol;
        outf.Write(pchar(x)^,length(x));
      end
      else begin
         x:= 'unconditional moment estimation.'+eol;
         outf.Write(pchar(x)^,length(x));
      end;
      (* MH: Unconditional estimation is default for implementing exogenous events *)
      if (exo) then begin
        x := 'This is the only option for networks of changing composition.'+eol;
        outf.Write(pchar(x)^,length(x));
      end;
      outf.Write(pchar(eol)^,length(eol));//writeln(outf);
    end; (* not Cconditional *)
  end; (* observations >= 2 *)
  Application.ProcessMessages;

  if (modelseed = 0) then
    begin
    x :='Random initialization of random number stream.'+eol;
    outf.Write(pchar(x)^,length(x));
    sed := readstate;
    x := format('%s%d%s',['Current random number seed is ',sed,'.'])+eol;
    outf.Write(pchar(x)^,length(x));
    end
   else
    begin
    x := format('%s%d',['Random number seed = ',modelseed])+eol;
    outf.Write(pchar(x)^,length(x));
    sed := readstate;
    end;
  makestate(sed);


  updatestat := (OutputType >= 2);

  if MaxLike then begin
    x := 'Simulated statistics are minus score functions for augmented data (likelihood approach).'+eol;
    outf.Write(pchar(x)^,length(x));
   end;

  if (not MaxLike) then begin
    outf.Write(pchar(eol)^,length(eol));//writeln(outf);
    x := 'Observed values of statistics are '+eol;
    outf.Write(pchar(x)^,length(x));
    x := '---------------------------------'+eol;
    outf.Write(pchar(x)^,length(x));
    for i:=1 to NumberFunctions do begin
      x := format('%3d%s%s%20.4f',[i,'. ',StatsDescriptions[i],Targets[i]])+eol;
      outf.Write(pchar(x)^,length(x));
     end; (* for i *)      outf.Write(pchar(eol)^,length(eol));//writeln(outf);
   end;

  if (nza >= 1) then
    begin
    x := 'Observed autocorrelation statistics '+eol;
    outf.Write(pchar(x)^,length(x));
    x := '----------------------------------- '+eol;
    outf.Write(pchar(x)^,length(x));
    k := 0;
    for j:=1 to nza do
      if (k < length(znames[nz+j])) then k := length(znames[nz+j]);
    for j :=1 to nza do
      for i:= length(znames[nz+j])+1 to k do znames[nz+j] := znames[nz+j]+' ';
    if (nza >= 2) then begin
      x := 'var.';
      for i:=4 to k do x := x+' ';
      outf.Write(pchar(x)^,length(x));
      x := 'obs.   Moran"s I       Geary"s c '+eol;
      outf.Write(pchar(x)^,length(x));
    end
     else begin
      x := 'obs.   Moran"s I       Geary"s c '+eol;
      outf.Write(pchar(x)^,length(x));
     end;
    for j:=1 to nza do
      begin
      for k:= 1 to observations do if not skipi[k] then
        begin
        if (nza >= 2) then begin
          x := znames[nz+j];
          outf.Write(pchar(x)^,length(x));
        end;
        x := format('%3d%s%6.3f%s%6.3f',[k,'      ',mi[j,k],'          ', gc[j,k]])+eol;
        outf.Write(pchar(x)^,length(x));
        end;
      end;
    end; (* if *)


(* Forms: *)
(* window ERun: nitr; from 1 to nrun *)
(* window StatsNames:
             StatsDescriptions[i] for i = 1,..., min(NumberFunctions,20) *)
(* window Statas:
             stats[i] for i = 1,..., min(NumberFunctions,20) *)

  SimForm.Caption := 'SIENA     Simulation for project <'+pname+'>';
  numberf := numberfunctions;
  if (numberf >= 21) then numberf := 21;
  HeightFactor := simform.PixelsPerInch/96;
  if (HeightFactor > 3.0) then HeightFactor := 3.0;
  if (HeightFactor < 0.3) then HeightFactor := 0.3;

  Simform.Height := round(Heightfactor*(150+NumberF*14));
  if SimForm.Height<450 then SimForm.Height:=450;

  Simform.Statsnames.Height := Simform.Statsnames.Font.Size-NumberF*Simform.Statsnames.Font.Height;
  Simform.statas.Height := Simform.statas.Font.Size-NumberF*Simform.statas.Font.Height;

  for i:=1 to NumberF
  do begin
    if ((i <= 9) and (NumberF > 9))
    then SimForm.Statsnames.lines[i-1] :=copy(' '+st(i)+'. '+StatsDescriptions[i],1,45)
    else begin
      if ((i=21) and (NumberFunctions>NumberF))
      then begin
        SimForm.Statsnames.lines.strings[i-1] := '   etcetera';
        SimForm.Statas.Lines.strings[i-1] :=  '   etcetera'
      end
      else begin
        SimForm.Statsnames.lines[i-1] := copy(st(i)+'. '+StatsDescriptions[i],1,45);
        SimForm.statas.lines[i-1] := 'value '+st(i)
      end
    end;
    Simform.Statsnames.selstart := 0;
    Simform.Statas.selstart := 0;
  end;

  SimForm.Label3.Caption := '(1-'+inttostr(niter)+')';
  Application.ProcessMessages;

  err := false;
  nitr := 0;
  writefreq := 10;
  IndependentStart := (observations >= 2) or (gibbs <= 7);
     (* this is only for the first run, and changed later on *)
  if (rstep >= 50) then writefreq := 1;
  if ((observations = 1) and (NumberFunctions < pmax)) then begin
    numberfun := numberfunctions+1;
    StatsDescriptions[NumberFun] :=
    'Fraction of Gibbs steps with a change                       ';
   end else begin
    if (nza >= 1) then
      begin
      numberfun := (pmax - numberfunctions) div (2*nza);
(* number of available observations for which the 2 network autocorrelation
   coefficients can be stored *)
      if (numberfun < observations-1) then
        numberfun := numberfunctions + 2*numberfun*nza
       else
        numberfun := numberfunctions + 2*nza*(observations-1);
        for i:=numberfunctions+1 to numberfun do
          begin
          if odd(i - numberfunctions) then
            stad := 'Moran autocor ' else stad := 'Geary autocor ';
          if (nza >= 2) then stad := stad +
//              ', var '+inttostr((((i - numberfunctions - 1) div 2) mod nza)+1);
              znames[nz+(((i - numberfunctions - 1) div 2) mod nza)+1];
          stad := stad + ', obs. '
                 +inttostr(((i - numberfunctions - 1) div (2*nza))+2) ;
          for j:= 60-length(stad) downto 1 do
            stad := stad + ' ';
          StatsDescriptions[i] := stad;  
          end; (* for i *)
      end
     else
      numberfun := numberfunctions;
   end;
  with SimForm do begin
    ymax := 1.0;
    xmax := nrun;
   end;

  pp := NumberParameters;
  Application.ProcessMessages;

  if (observations <= 1) and (gibbs >= 8) then SetDigraph(1);


  GenerateMany := false;

  if (niter <= 1) or GenerateMany then
    begin
    for i:=1 to niter do
      begin
      SimOnce(i,GenerateMany,pp,theta,true,false,sed,stats,feasible,err,erstr,outf,lf);
      if GenerateMany then
        begin
        assignfile(fff,'n.bat');
        if fileexists('n.bat') then append(fff) else rewrite(fff);
        writeln(fff,'start /w siena01 sim'+inttostr(i));
        writeln(fff,'start /w siena03 sim'+inttostr(i)+' f simch.txt');
        writeln(fff,'start /w siena07 sim'+inttostr(i));
        writeln(fff,'copy sisim'+inttostr(i)+'.d02 sisim.d01');
        writeln(fff,'start /w siena03 sisim f simch1.txt');
        writeln(fff,'start /w siena07 sisim');
        writeln(fff);
        closefile(fff);
        end;
      end;
    closefile(datf);
    exit;
    end;



  if MaxLike then
    begin
    SimForm.BurninText.visible := true;
    SimForm.BurninText.caption := 'initialisation';
    Application.ProcessMessages;
    MLInitialise(pp, theta,outf,lf);
    nrunMH := trunc(rstep*ObservedNetworkDistance[1,1]);
    if (nrunMH < 2) then nrunMH := 2;
    x := format('%d%s',[nrunMH ,' MCMC steps per RM step (multiplication factor = ']);
    outf.Write(pchar(x)^,length(x));
    if (rstep < 0.5) then begin
      x := format('%6.4f%s',[ rstep,').'])+eol;
      outf.Write(pchar(x)^,length(x));
    end
      else begin
        x := format('%4.1f%s',[rstep,').'])+eol;
        outf.Write(pchar(x)^,length(x));
      end;
    end;
(* TS 05-jan-05 It is possible that this procedure contains
   a number of statements that should be used only for estimation.
   In that case, use the variable "estimation" to exclude them. *)

(* TS 05-jan-05. The following multiplication is necessary,
   to get correct conditional simulations with several
   rate parameters. *)
  if (Cconditional and (nxa + nza >= 2)) then begin
   for i:=1 to observations-1 do if (not skipi[i]) then begin
      if (ConditioningNetworkVariable =1) then time1 := alpa_l[i]
       else time1 :=alpa_l[NetworkEffects_l+(ConditioningActionVariable-1)*(observations-1)+i];
      alpa_l[i] := alpa_l[i]/time1;
      for j:=1 to nza do
        alpa_l[NetworkEffects_l+(j-1)*(observations-1)+i] :=
         alpa_l[NetworkEffects_l+(j-1)*(observations-1)+i]/time1;
     end; (* for i *)
    SetTheta(theta);
   end; (* if Cconditional and (nxa + nza >= 2)  *)

// @@@  NewNetworkEffects.WriteStatSequenceIndices(outf);
  (* kan ter controle worden toegevoegd; evt. later naar logfile *)

  time1 := now;
  time0 := now;
  Application.ProcessMessages;
  pc := false;
  if MaxLike then
    begin
    feasible := true;
    esta := 22;
    end;
  repeat
     inc(nitr);
     if MaxLike then
       begin
       if (nitr <= 1) then
         begin
         SimForm.BurninText.caption := 'burn-in';
         Application.ProcessMessages;
//         nrunMH0 := nrunMH;
         nrunMH := 20*nrunMH;
         end;
       if (nrun = 10) and (nitr = 10) then
         begin
         writechain := true;
         assignfile(chainfile,pname+'.cha');
         rewrite(chainfile);
         end;
       end;
     if ((observations = 1) and (nitr >= 2)) then IndependentStart := false;
     FRAN(pp,theta,true,false,sed,stats,dd,pm,updatestat,feasible,err,erstr,outf,lf,esta,pc);
//     if (nitr <= 1) then NewNetworkEffects.WriteMod_fSequenceParameters(alpa_f,outf);
  (* kan ter controle @@@ *)
     if MaxLike then
       begin
       if (nitr <= 1) then
         begin
         nrunMH := nrunMH div 20;
         SimForm.BurninText.visible := false;
         end;
       if (nrun = 10) and (nitr = 10) then
         begin
         writechain := false;
         closefile(chainfile);
         end;
       end;

     if (nitr = 10) then begin
       time1 := 86400*(now - time1);
        (* number of seconds elapsed in 10 FRANs *)
        if (time1 > 1e-5)
          then writefreq := round(2.0/time1)
          else writefreq := 10;
//       writefreq := round(2.0/time1);
       roundfreq(writefreq);
      end; (* if nitr = 10 *)

// The following lines for drawing the graph are not activated
// because this button was made inactive.
//     if cconditional then iy := stats[3]/(n*(n-1.0)*(n-2.0))
//      else iy := nties/(n*(n-1.0));
//     if Graphix then with SimForm do begin
//       Drawxaxis(0.0,nrun);
//       Drawyaxis(0.0,1.0);
//       with Graphic1 do begin
//         ix := nitr;
//         draw1(ix,iy);
//        end;
//      end;

     if ((not feasible) and (nitr = 1)) then begin
       err := true;
       erstr := 'This distance is not achieved for this parameter vector.';
      end;

     for i:=1 to NumberFun do begin
       sums[i] := sums[i] + stats[i];
      if (nitr >= 2) then sumslag[i] := sumslag[i] + statslag[i]*stats[i];
       for j:=1 to NumberFun do begin
        sums2[i,j] := sums2[i,j] + stats[i]*stats[j];
        end;
       write(datf,stats[i]:11:4,' ');
      end; (* i *)
     for i:=1 to NumberFun do statslag[i] := stats[i];
     if (nitr <= 10) or ((nitr mod writefreq) = 0) then
      begin
       SimForm.ERun.Text:=inttostr(nitr);
       for i:=1 to NumberFunctions do begin
         NiceString(stats[i],s);
         if (i <= 9)
         then SimForm.statas.lines[i-1] := copy(' '+st(i)+'.  '+s,1,15);
         if ((i >= 10) and (i <= 20))
         then SimForm.statas.lines[i-1] := copy(st(i)+'.  '+s,1,15);
        end;
        Simform.statas.selstart := 0;
      end;
     writeln(datf);
{$if defined(batch)}
     writeln('Iteration number ',nitr,' of ',niter);
{$ifend}
     if stops then begin
        x := format('%s%d%s',['Iterations interrupted by user after ',nitr,' simulations.'])+eol;
        lf.Write(pchar(x)^,length(x));
        nrun := nitr-1;
      end;
    until ((nitr >= nrun) or err);

  closefile(datf);


  if err then begin
    x := 'Error in some simulations : '+eol;
    lf.Write(pchar(x)^,length(x));
    x := erstr+eol;
    lf.Write(pchar(x)^,length(x));
    outf.Write(pchar(eol)^,length(eol));//writeln(outf);
    x := 'Error in some simulations : '+eol;
    outf.Write(pchar(x)^,length(x));
    x := erstr+eol;
    outf.Write(pchar(x)^,length(x));
    x := 'Error occurred for parameter values '+eol;
    outf.Write(pchar(x)^,length(x));
    for i:=1 to NumberParameters do begin
          x := format('%s%s%20.12f',[Description[i],' ',theta[i]])+eol;
          outf.Write(pchar(x)^,length(x));
    end;
   end else begin
    for i:=1 to NumberFun do sums[i] := sums[i]/nrun;
    for i:=1 to NumberFun do begin
      if (nrun >= 3) then
        sumslag[i] := ((nrun-1)/(nrun-2))*(sumslag[i]/(nrun-1) - sqr(sums[i]))
       else sumslag[i] := 0.0;
      for j:=1 to NumberFun do if (nrun >= 3) then
        sums2[i,j] := (nrun/(nrun-1))*(sums2[i,j]/nrun - sums[i]*sums[j])
       else sums2[i,j] := 0.0;
     end; (* i *)

   n := nni[observations-1];
   if (updatestat and (not MaxLike)) then for i:=1 to n do begin
     j:= -1; demod := 0;
     while ((demod < 0.05*nrun) and (j < n)) do begin
       Inc(j);
       demod := demod+SimDegrees[i,j];
      end;
     perc5[i] := j;
     while ((demod < 0.5*nrun) and (j < n)) do begin
       Inc(j);
       demod := demod+SimDegrees[i,j];
      end;
     perc50[i] := j;
     repeat
       Inc(j);
       demod := demod+SimDegrees[i,j];
      until ((demod >= 0.95*nrun) or (j >= n));
     perc95[i] := j;
    end; (* i *)

  if MaxLike then begin
     for i:=1 to NumberParameters do
      StatsDescriptions[i] := 'minus score function for parameter ' + inttostr(i);
   end;


    results(nrun,NumberFun,sums,sums2,sumslag,perc5,perc50,perc95,outf);

   end; (* if not error *)

   if MaxLike then
     begin
     extraMLResults(lf);
     MLFinalizePeriods(outf,lf);
     end;

  if ((observations <= 1) and (not (Gibbs in [2,3,8])))
    then CheckRunningStatistics(outf,lf);

  time0 := 86400*(now - time0);
  x := format('%s%8.2f%s',['Total computation time ',time0,' seconds.'])+eol;
  outf.Write(pchar(x)^,length(x));

  finalize(dd);
end; (* Activity.Simulate *)


begin (* unit S_sim *)
end.
