unit siena_7;

interface

uses
{$if not defined(linux)}
Windows,
{$ifend}
Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
StdCtrls, Buttons,
 {$if defined(lazarus)}
 lresources,
 {$else}
 jpeg,
 {$ifend}
s_constants, rangen, eight, slib, s_dat,  s_base,  s_est, s_test,
s_theta,
ExtCtrls, ComCtrls, s_ml, s_matrices, Menus;
 procedure TEstFormFormActivate;
type

  { TEstForm }

  TEstForm = class(TForm)
    Label2: TLabel;
    StopKey: TBitBtn;
    ParameterValues: TMemo;
    EPhase: TEdit;
    LPhase: TLabel;
    LSubphase: TLabel;
    ESubphase: TEdit;
    LIteration: TLabel;
    EIteration: TEdit;
    BTheta: TButton;
    BSetN: TButton;
    BEnd2: TButton;
    QAutocor: TMemo;
    Label1: TLabel;
    Statistics: TMemo;
    Label3: TLabel;
    HelpInfoScreen: TEdit;
    HelpInfoLabel: TLabel;
    Background: TImage;
    ProgressBar: TProgressBar;
    PLtext: TLabel;
    Graphic1: TPaintBox;
    procedure Startup(m: integer);
    procedure StopKeyClick(Sender: TObject);
  //  procedure FormActivate(Sender: TObject);
    procedure BSetNClick(Sender: TObject);
    procedure BEnd2Click(Sender: TObject);
    procedure BThetaClick(Sender: TObject);
    procedure Startpaint;
    function xcoor(t: real): integer;
    function ycoor(t: real): integer;
    procedure Drawxaxis(x0,x1: real);
    procedure Drawyaxis(y0,y1: real);
    procedure VertLine(x: real);
    procedure HorLine(y: real);
    procedure Draw1(x,y: real);
  private
    { Private declarations }
  public
    { Public declarations }
    xmin, xmax, ymin, ymax: real;
  end;

var
  EstForm: TEstForm;
  outfile, lf: TFilestream;
  ContinueDigraph: Activity;
  apf: boolean;

implementation

procedure TEstForm.StopKeyClick(Sender: TObject);
begin
  if MessageDlg('Are you sure you want to stop the estimation process?',
                  mtConfirmation,[mbYes, mbNo],1)
  = mrYes then stopo:=true
end;

procedure TEstFormFormActivate();
var halter: Boolean;
  u4: byte;
  i: integer;
  seed, u: real;
  fseed: integer;
  est, ste,
  ct, targ: pvec;
  u1, u2: pbvec;
  errortext: shortstring;
  writedate, halterr: boolean;
  x : string;
(* est and ste used only for compatibility with s_est8 *)
begin
simulate := false; (*MS: change this to 'true' for simulations*)
{
(*The following lines are useful for specific Monte Carlo simulations involving
estimation and tests of misspecified models.*)
i := 20;
u := -10.0;
ModelReSpecification(i,u);
}
altern := false; (*MS: indicates whether or not data are to be generated according
to a model where some homogeneity assumption is violated: used in Monte Carlo simulation.*)
d_estAB := false;
d_estA := false;
d_estB := false;
(*MS:
boolean is true when the model
- is to be estimated (rather than simulated)
- by the method of moments
- and the algorithm is in phase 3.
The value will be manipulated during run-time: see <Initialise_d_est>.
*)
run := 0;
while (run < sequences) do (*MS: multiple sequences*)
  begin
  run := run + 1;
  hit := false;
  errortext := '';
  halter := false;
  ComlineString(CurrentProjectName);
  stopo := false;
  nexto := false;
  starto := false;
  nextt := false;
 with ContinueDigraph do (*MS: generation of data sets according to specified probability models.*)
    begin
    apf := true;
    if simulate then
      begin
      {
      MS: comment:
      The following procedures can be exploited to simulate data and then
      estimate misspecified models:
      StoreOriginal;
      AlternativeModel; (*MS: respecifies the model given in <pname.mo3>.*)
      }
      writedate := true;
      pname := CurrentProjectName;
      Outputfiles(apf,writedate,pname,outfile,lf);
      ReadDefinition1(halterr,outfile,lf);
      ReadDefinition2(pname,halterr,outfile,lf); (*Creates NewnetworkEFfects, should be done only once *)
      changeparameter := true;
      InitialiseBase1(outfile,lf);
      changeparameter := false;
      ReviseDefinition(halter,outfile,lf);
      InitialiseBase2(est,outfile,lf);
      seedsown := false;
      MakeState(fseed);
      InitialiseAlpha(outfile,est,fseed);
      SimulateData(outfile,lf); (*MS: Simulates data according to the probability model specified in <pname.mo>.*)
      hit := true;
      {
      StoreAlternative;
      OriginalModel; (*Respecifies the model so that the original model is used in estimation and testing.*)
      }
      DeActivateModel(outfile);
      end;
    end;
  if randomeffects then (* TS: condition added, 27-4-07 *)
  with ContinueDigraph do (*MS: random effects models: initial estimates of fixed effects.*)
    begin
    halter := false;
    ComlineString(CurrentProjectName);
    stopo := false;
    nexto := false;
    starto := false;
    nextt := false;
    apf := true;
    AttachProject(CurrentProjectName,CurrentProjectName,
                  halter,outfile,lf,apf,true); (*MS: read data.*)
    if (not halter) then
      begin
      InitialiseBase1(outfile,lf);
      InitialiseBase2(est,outfile,lf);
      ReviseDefinition(halter,outfile,lf);
      IndicateFixedThetaAndRC(u1,u2);
      if (maxlike or Bayesian) then (*MS: random effects model: obtain initial estimates of fixed effects by unconditional moment estimation.*)
        begin
        initialFEestimate := initialFEestimate_input;
        if initialFEestimate then Estimate(halter,est,ste,ct,outfile,lf); (*Add nothing to time series...*)
        (*
        An alternative, bad starting point (to detect possible non-convergence):
        est[1] := 1; for i := 2 to pmax do est[i] := 0;
        *)
        initialFEestimate := false; (*Default*)
        end;
      end; (*if not halter*)
    DeActivateModel(outfile);
    end; (*with ContinueDigraph do*)
  with ContinueDigraph do (*MS: estimate model.*)
    begin
    halter := false;
    ComlineString(CurrentProjectName);
    stopo := false;
    nexto := false;
    starto := false;
    nextt := false;
    apf := true;
    AttachProject(CurrentProjectName,CurrentProjectName,
                  halter,outfile,lf,apf,true); (*MS: read in.*)
    InitialiseBase1(outfile,lf);
    if (not halter) then begin
      ReviseDefinition(halter,outfile,lf);
      if (sequences > 1) then
        begin
        if (run = 1) then
          begin
          //writeln(outfile); writeln(outfile);
          outfile.Write(pchar(eol)^,length(eol));
          outfile.Write(pchar(eol)^,length(eol));
          x := format('%d%s',[sequences,' sequences to be executed...'])+eol;
          outfile.Write(pchar(x)^,length(x));
          end;
        //writeln(outfile);
        //writeln(outfile);
        outfile.Write(pchar(eol)^,length(eol));
        outfile.Write(pchar(eol)^,length(eol));
        Heading(1,outfile,'Sequence '+inttostr(run));
        end;
      Estimate(halter,est,ste,ct,outfile,lf); (*Estimation procedure...*)
      end; (*if not halter*)
    lf.free;
    DeActivateModel(outfile);
    outfile.free;
    end; (*with ContinueDigraph do*)
  end; (*MS: Multiple sequences.*)
EstForm.DeActivate;
//closefile(exf);
EstForm.Close;
end;

procedure TEstform.Startup(m: integer);
var p,i,
    fontsize      : integer;
    HeightFactor  : real;
begin
  HeightFactor := PixelsPerInch/96;
  if (HeightFactor > 3.0) then HeightFactor := 3.0;
  if (HeightFactor < 0.3) then HeightFactor := 0.3;
  with ThetaForm.SGTheta
  do begin
    ColWidths[0]:=210;
    ColWidths[1]:=70;
    height := round(HeightFactor*(10 + m*21));
    rowcount := m;
  end;
  with ThetaForm.GBTheta
  do begin
    height := round(HeightFactor*(40+m*21));
  end;
  p := m;
  with ContinueDigraph
  do if ((observations = 1) and Continuous)
     then QAutoCor.hint := '';
  Height := round(HeightFactor*480);
  if m<=30 then p:=m else p:=30;
  fontsize := 8;
  while (p*trunc(1+FontSize*PixelsPerInch/72)>HeightFactor*280) and (fontsize>4)
  do dec(fontsize);
  Caption := 'SIENA      Estimation for project <'+ContinueDigraph.pname+'>';
  with Parametervalues
  do begin
    Font.Size := fontsize;
    Height := Font.Size-p*Font.Height;
    for i:=1 to p
    do lines.strings[i-1] := 'value '+st(i)
  end;
  with QAutocor
  do begin
    Font.Size := fontsize;
    Height := Font.Size-p*Font.Height;
    for i:=1 to p
    do lines.strings[i-1] := '----'
  end;
  with Statistics
  do begin
    Font.Size := fontsize;
    Height := Font.Size-p*Font.Height;
    for i:=1 to p
    do lines.strings[i-1] := 'value '+st(i)
  end
end;

procedure TEstForm.BSetNClick(Sender: TObject);
begin
  if MessageDlg('Are you sure you want to start again with n=0?',
               mtConfirmation,[mbYes, mbNo],1)
  = mrYes then starto:=true;
end;

procedure TEstForm.BEnd2Click(Sender: TObject);
begin
  if MessageDlg('Are you sure you want to end phase 2?',
                mtConfirmation,[mbYes, mbNo],1)
  = mrYes then nexto:=true;
end;

procedure TEstForm.BThetaClick(Sender: TObject);
begin
  if MessageDlg('Are you sure you want to change the current parameter values?',
                  mtConfirmation,[mbYes, mbNo],1)
  = mrYes then nextt:=true;
end;


procedure TEstForm.Startpaint;
begin
 with Graphic1 do begin
   Canvas.Pen.Color := clRed;
   SetBkMode(Canvas.Handle,OPAQUE);
   SetBkColor(Canvas.Handle,clWhite);
   Canvas.Font.Color := clRed;
   Canvas.Brush.Color := clWhite;
   Canvas.Pen.Color := clBlack;
   Canvas.Rectangle(0,0,graphic1.width,graphic1.height);
   Canvas.Font.Color := clBlack;
   Canvas.Pen.Color := clBlack;
 end;
end; (* startpaint *)


function TEstForm.xcoor(t: real): integer;
  begin
    xcoor := round(graphic1.width*(0.1 + 0.8*(t-xmin)/(xmax-xmin)));
  end;

function TEstForm.ycoor(t: real): integer;
  begin
    ycoor := round(graphic1.height*(0.9 - 0.8*(t-ymin)/(ymax-ymin)));
  end;

procedure TEstForm.Drawxaxis(x0,x1: real);
var i: integer; s: shortstring;
begin
  with Graphic1 do
  with Canvas do begin
   Brush.style := bsClear;
   Font.Color := clBlack;
   MoveTo(xcoor(xmin),ycoor(ymin));
   LineTo(xcoor(xmax),ycoor(ymin));
   for i:=0 to 10 do begin
     MoveTo(xcoor(i*(xmax-xmin)/10), ycoor(ymin));
     LineTo(xcoor(i*(xmax-xmin)/10), ycoor(ymin)-10);
    end;
   NiceString2(x0,s);
   Textout(xcoor(xmin)-5, ycoor(ymin)+5, s);
   NiceString2(x1,s);
   Textout(xcoor(xmax)-5, ycoor(ymin)+5, s);
  end; (* with Graphic1 with Canvas *)
end; (* Drawxaxis *)

procedure TEstForm.Drawyaxis(y0,y1: real);
var i: integer; s: shortstring;
begin
  with Graphic1 do
  with Canvas do begin
   Font.Color := clBlack;
   MoveTo(xcoor(xmin),ycoor(ymin));
   LineTo(xcoor(xmin),ycoor(ymax));
   for i:=0 to 10 do begin
     MoveTo(xcoor(xmin), ycoor(i*(ymax-ymin)/10));
     LineTo(xcoor(xmin)+10, ycoor(i*(ymax-ymin)/10));
    end;
   NiceString2(y0,s);
   Textout(xcoor(xmin)-15, ycoor(ymin)-5, s);
   NiceString2(y1,s);
   Textout(xcoor(xmin)-15, ycoor(ymax)-5, s);
  end; (* with Graphic1 with Canvas *)
end; (* Drawyaxis *)

procedure TEstForm.VertLine(x: real);
begin
  with Graphic1 do with Canvas do begin
    MoveTo(xcoor(x),ycoor(ymin));
    LineTo(xcoor(x),ycoor(ymax));
   end;
end;

procedure TEstForm.HorLine(y: real);
begin
  with Graphic1 do with Canvas do begin
    MoveTo(xcoor(xmin),ycoor(y));
    LineTo(xcoor(xmax),ycoor(y));
   end;
end;

procedure TEstForm.Draw1(x,y: real);
var OldColor: Tcolor;
begin
  with Graphic1 do begin
   Oldcolor := Font.color;
   Canvas.Ellipse(xcoor(x),ycoor(y),xcoor(x)+2,ycoor(y)+2);
   Font.Color := Oldcolor;
  end; (* with graphic1 *)
end;
{$if not defined(lazarus)}
{$R *.DFM}
{$ifend}

initialization
begin
{$if defined(lazarus)}
{$I siena_7.lrs}
{$ifend}
 run := 1;
 ContinueDigraph.estimation := true;
 CallingProgram := 7;
end;

end.

